#!/usr/bin/perl -w
#
# swap.cgi
# John Simpson <jms1@jms1.net>
#
# Swap a rule with the one after it
#
# $Id: swap.cgi 106 2012-07-21 20:39:17Z jms1 $
#
###############################################################################
#
# Copyright (C) 2012 John M. Simpson.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 or version 3 of the
# license, at your option.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

require 5.003 ;
use strict ;
use CGI qw ( :standard ) ;

use Rules ;

###############################################################################
###############################################################################
###############################################################################

require_login() ;

########################################
# Read form (URL) data.

my $phase = ( param ( 'phase' ) || '' ) ;
my $seq   = ( param ( 'seq'   ) || '' ) ;

unless ( $phase && $seq )
{
	logit "Either phase \"$phase\" or seq \"$seq\" is missing." ;
	redirect_home() ;
}

########################################
# make sure the user is authorized to change rules in this phase

my $query = "SELECT level FROM phases WHERE phase = $phase" ;
my $plevel = SQL_select ( $query ) ;
$plevel ||= 0 ;

if ( $access < $plevel )
{
	logit "ERROR: attempt to delete rule without proper access:"
		. " phase=[$phase] seq=[$seq] plevel=[$plevel]"
		. " access=[$access] userid=[$userid]\n" ;
	redirect_home() ;
}

########################################
# Do the deed.

my $next_seq = $seq + 1 ;

SQL_transaction() ;

$query = "UPDATE rules SET seq = -1 WHERE "
	. SQL_quote ( $focus ) . ' LIKE recipient'
	. " AND phase = $phase AND seq = $seq" ;
SQL_do ( $query ) ;

$query = "UPDATE rules SET seq = $seq WHERE "
	. SQL_quote ( $focus ) . ' LIKE recipient'
	. " AND phase = $phase AND seq = $next_seq" ;
SQL_do ( $query ) ;

$query = "UPDATE rules SET seq = $next_seq WHERE "
	. SQL_quote ( $focus ) . ' LIKE recipient'
	. " AND phase = $phase AND seq = -1" ;
SQL_do ( $query ) ;

SQL_commit() ;

########################################
# done

redirect_home() ;
